/*
	Copyright (c) 2011 Oracle, Inc.
	All rights reserved

	THIS IS UNPUBLISHED PROPRIETARY
	SOURCE CODE OF ORACLE, Inc.
	The copyright notice above does not
	evidence any actual or intended
	publication of such source code.
*/


/*	(c) 2003 BEA Systems, Inc. All Rights Reserved. */
/*	Copyright (c) 1997 BEA Systems, Inc.
  	All rights reserved

  	THIS IS UNPUBLISHED PROPRIETARY
  	SOURCE CODE OF BEA Systems, Inc.
  	The copyright notice above does not
  	evidence any actual or intended
  	publication of such source code.
*/

/* #ident	"@(#) samples/atmi/simpapp/simpserv.c	$Revision: 1.7 $" */

#include <stdio.h>
#include <ctype.h>
#include <atmi.h>	/* TUXEDO Header File */
#include <userlog.h>	/* TUXEDO Header File */
#include <xa.h>
#include <sql.h>
#include <sqlext.h>
#include <string.h>


/* tpsvrinit is executed when a server is booted, before it begins
   processing requests.  It is not necessary to have this function.
   Also available is tpsvrdone (not used in this example), which is
   called at server shutdown time.
*/


int tpsvrinit(int argc, char *argv[])
{
	int ret;

	/* Some compilers warn if argc and argv aren't used. */
	argc = argc;
	argv = argv;

	/* simpapp is non-transactional, so there is no need for tpsvrinit()
	   to call tx_open() or tpopen().  However, if this code is modified
	   to run in a Tuxedo group associated with a Resource Manager then
	   either a call to tx_open() or a call to tpopen() must be inserted
	   here.
	*/

	/* userlog writes to the central TUXEDO message log */
	userlog("Welcome to the simple server");

    	ret = tpopen();

	userlog("tpopen returned %d, error=%x", ret, tperrno );

	return(0);
}

void tpsvrdone( void )
{
	int ret;

	ret = tpclose();

	userlog("tpclose returned %d", ret);
}

/* This function performs the actual service requested by the client.
   Its argument is a structure containing among other things a pointer
   to the data buffer, and the length of the data buffer.
*/

int es_xa_context( int* rmid, SQLHANDLE* henv, SQLHANDLE* hdbc );

void EXECUTE(TPSVCINFO *rqst)
{
	int ret;
	char *result;
	SQLHANDLE hStmt;
	char str[ 256 ];
	SQLHANDLE hEnv, hConn;
	SQLSMALLINT slen;

	ret = es_xa_context( NULL, &hEnv, &hConn );

	userlog("es_xa_context returns %d, hEnv = %p, hConn = %p", ret, hEnv, hConn );

	if ( ret != 0 ) {
		result = tpalloc( "STRING", "*", 128 );
		sprintf( result, "es_xa_context returned %d", ret );

		/* Return the transformed buffer to the requestor. */
		tpreturn(TPSUCCESS, 0, result, strlen( result ), 0);
	}
	else {
	
		ret = tpbegin( 0, 0 );
	
		ret = SQLAllocHandle( SQL_HANDLE_STMT, hConn, &hStmt );

		ret = SQLExecDirect( hStmt, rqst -> data, rqst -> len );
			
		ret = SQLFreeHandle( SQL_HANDLE_STMT, hStmt );
	
		ret = tpcommit( 0 );
	
		result = tpalloc( "STRING", "*", 128 );
		sprintf( result, "tpcommit returns %d", ret );
	
		/* Return the transformed buffer to the requestor. */
		tpreturn(TPSUCCESS, 0, result, strlen( result ), 0);
	}
}
